Bug 24492 - Add a 'library cashup' workflow to the point of sale system
Summary: Add a 'library cashup' workflow to the point of sale system
Status: Pushed to master
Alias: None
Product: Koha
Classification: Unclassified
Component: Fines and fees (show other bugs)
Version: master
Hardware: All All
: P5 - low enhancement (vote)
Assignee: Martin Renvoize
QA Contact: Testopia
URL:
Keywords:
Depends on: 24082
Blocks: 13985
  Show dependency treegraph
 
Reported: 2020-01-23 14:12 UTC by Martin Renvoize
Modified: 2020-05-18 14:51 UTC (History)
2 users (show)

See Also:
Change sponsored?: ---
Patch complexity: ---
Who signed the patch off:
Text to go in the release notes:
This enhancement adds a new 'library details' page to the POS system which displays a summary of the cash register transactions for a library since each register was last cashed up. It also allows for cashing up individual registers or cashing up all registers at a given library in one transaction.
Version(s) released in:
20.05.00


Attachments
Bug 24492: Add branch details page (10.57 KB, patch)
2020-01-23 14:18 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 24492: Add branch details page (10.64 KB, patch)
2020-01-28 10:25 UTC, David Nind
Details | Diff | Splinter Review
Bugs 24492 - Screenshot of POS screen (59.16 KB, image/png)
2020-01-28 10:36 UTC, David Nind
Details
Bug 24492: Add branch details page (10.63 KB, patch)
2020-03-04 20:16 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24492: Update GPL license (1.85 KB, patch)
2020-03-04 20:16 UTC, Kyle M Hall
Details | Diff | Splinter Review
Bug 24492: Add branch details page (15.03 KB, patch)
2020-03-05 12:55 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 24492: Update GPL license (1.84 KB, patch)
2020-03-05 12:55 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 24492: (RM follow-up) Redirect to correct page after cashup (2.28 KB, patch)
2020-03-05 14:18 UTC, Martin Renvoize
Details | Diff | Splinter Review
Bug 24492: (RM follow-up) Varaible name corretion (1.68 KB, patch)
2020-04-06 09:38 UTC, Martin Renvoize
Details | Diff | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Martin Renvoize 2020-01-23 14:12:06 UTC
Bug 23355 adds a cashup workflow for individual cash registers, but it would be nice to have a branch summary and cashup option too.
Comment 1 Martin Renvoize 2020-01-23 14:18:48 UTC
Created attachment 97824 [details] [review]
Bug 24492: Add branch details page

This patch adds a new 'branch details' page to the POS system which
displays a summary of the cash register transactions for a branch
since each register was last cashed up. It also allows for cashing
up individual registers or cashing up all registers at a given branch
in one transaction.

Signed-off-by: Kyle M Hall <kyle@bywatersolutions.com>
Comment 2 David Nind 2020-01-28 10:25:59 UTC
Created attachment 98019 [details] [review]
Bug 24492: Add branch details page

This patch adds a new 'branch details' page to the POS system which
displays a summary of the cash register transactions for a branch
since each register was last cashed up. It also allows for cashing
up individual registers or cashing up all registers at a given branch
in one transaction.

1) Enable the point of sale feature (EnablePointOfSale + UseCashRegister system preferences)
2) Add a cash register for a library (Home > Point of sale > Cash registers > New cash register)
3) Add some items that can be purchased (Home > Point of sale > Purchase items > New debit type)
   . Enter a 'Debit type code', 'Default amount', 'Description', tick 'Can be manually invoiced?' and 'Can be sold?', and select 'All libraries' for the 'Libraries limitation'
   . Repeat so that you have two or three items
4) Add a sales transaction
   . Home > Point of sale
   . Click on 'Add' next to an item in the 'Items for purchase' area
   . Add another item
   . Under the 'Collect payment' area  enter the amount collected from the patron
   . Click 'Confirm'
   . Keep a record of the transactions for step 7
   . Repeat and add another sales transaction
5) Go to the Branch details screen - this lists the cash registers for the branch and allows you to 'Record cashup' either for an individual register all all registers
6) Click on 'Record cashup' button for the cash register setup in step 2
7) This lists all the transactions - check that transactions match with the transactions you entered
8) Check that the summary figires match
9) From the cash registers screen check that you can archive and restore a cash register
10) Form the cash registers screen check that you can change the details for a cash register
11) Sign-off bug!

Signed-off-by: Kyle M Hall <kyle@bywatersolutions.com>

Signed-off-by: David Nind <david@davidnind.com>
Comment 3 David Nind 2020-01-28 10:36:14 UTC
Created attachment 98020 [details]
Bugs 24492 - Screenshot of POS screen

Just a couple of minor points on the screen layout:

- In the items for purchase area the search box and labels are not aligned very well. This applies to the show entries label as well. (Tested on Google Chrome and Firefox).

- It may be better to have the 'Confirm' button and 'Cancel' link under the collect payment section to better fit a normal workflow: add items, enter payment details then press confirm.
Comment 4 Kyle M Hall 2020-03-04 20:16:15 UTC
Created attachment 100153 [details] [review]
Bug 24492: Add branch details page

This patch adds a new 'branch details' page to the POS system which
displays a summary of the cash register transactions for a branch
since each register was last cashed up. It also allows for cashing
up individual registers or cashing up all registers at a given branch
in one transaction.

Signed-off-by: Kyle M Hall <kyle@bywatersolutions.com>

Signed-off-by: David Nind <david@davidnind.com>
Comment 5 Kyle M Hall 2020-03-04 20:16:24 UTC
Created attachment 100154 [details] [review]
Bug 24492: Update GPL license

Signed-off-by: Kyle M Hall <kyle@bywatersolutions.com>
Comment 6 Martin Renvoize 2020-03-05 12:55:55 UTC
Created attachment 100189 [details] [review]
Bug 24492: Add branch details page

This patch adds a new 'branch details' page to the POS system which
displays a summary of the cash register transactions for a branch
since each register was last cashed up. It also allows for cashing
up individual registers or cashing up all registers at a given branch
in one transaction.

Signed-off-by: David Nind <david@davidnind.com>
Signed-off-by: Kyle M Hall <kyle@bywatersolutions.com>
Comment 7 Martin Renvoize 2020-03-05 12:55:58 UTC
Created attachment 100190 [details] [review]
Bug 24492: Update GPL license

Signed-off-by: Kyle M Hall <kyle@bywatersolutions.com>
Comment 8 Martin Renvoize 2020-03-05 12:56:30 UTC
Just a last rebase before pushing :).. Thanks for testing guys
Comment 9 Martin Renvoize 2020-03-05 13:06:21 UTC
Nice work everyone!

Pushed to master for 20.05
Comment 10 Martin Renvoize 2020-03-05 14:18:13 UTC
Created attachment 100196 [details] [review]
Bug 24492: (RM follow-up) Redirect to correct page after cashup

Cashup of a single register was resulting in a redirect to the register
details page. It should return to the branch details page instead.

Signed-off-by: Martin Renvoize <martin.renvoize@ptfs-europe.com>
Comment 11 Joy Nelson 2020-04-01 22:12:04 UTC
enhancement not backported to 19.11.x
Comment 12 Martin Renvoize 2020-04-06 09:38:20 UTC
Created attachment 102433 [details] [review]
Bug 24492: (RM follow-up) Varaible name corretion

Bug 24492 was not correctly rebased after bug 23355 and did not account
for a variable name change in the 'add_cashup' action. This patch deals
with that.

Signed-off-by: Martin Renvoize <martin.renvoize@ptfs-europe.com>
Comment 13 Martin Renvoize 2020-04-06 09:38:42 UTC
Nice work everyone!

Pushed to master for 20.05